#ifdef PREPROCESS_DOCUMENTATION
#include "..\lib\networkObject.hpp"
#endif

// Procedures
#ifdef INSIDE_RESOURCE
#else

enum IDS
{
	#define STRING(x) IDS_##x,
	#include "stringids.hpp"
	#undef STRING
	IDSN
};
RString LocalizeString(IDS ids);
RString LocalizeString(int ids);
RString LocalizeString(const char *str);
//RString LoadLocalString(const char *str);
RString Localize(RString str);

struct StringTableItem
{
	const char *name;
	RString value;
};

struct StringTableItem2
{
	RString name;
	RString value;

	StringTableItem2() {}
	StringTableItem2(RString n, RString v) {name = n; value = v;}
	const char *GetKey() const {return name;}
};
TypeIsMovableZeroed(StringTableItem2)

typedef MapStringToClass< StringTableItem2, AutoArray<StringTableItem2> > StringTableMap;
class StringTableDynamic : public StringTableMap
{
	typedef StringTableMap base;
public:
	void Add(RString name, RString value);
	void Load(const char *filename);
};

class StringTable
{
	friend RString LocalizeString(IDS ids);
	friend RString LocalizeString(const char *str);
	friend class StringTableDynamic;
protected:
	StringTableItem _table[IDSN];
	StringTableDynamic _table2;

public:
	StringTable(const char *filename);

	void Init();
	void Load(const char *filename);

	// implementation
protected:
	int FindStringIndex(const char *str);
};

extern RString GLanguage;
extern SRef<StringTable> GStringTable;
extern StringTableDynamic CampaignStringTable;
extern StringTableDynamic MissionStringTable;

#endif
